
package de.ivu.elect.presentation.aufgabe;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.aufgabe.boundary.AufgabeConversationStore;
import de.ivu.elect.business.aufgabe.boundary.AufgabeExtendedDAO;
import de.ivu.elect.business.aufgabe.boundary.AufgabeEdit;
import de.ivu.elect.business.aufgabe.entity.Aufgabe;
import de.ivu.elect.business.aufgabe.entity.AufgabeMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractAufgabeEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractAufgabeEditNoScopeView.VIEW_ID, useCase = UseCasePermission.AUFGABE_EDIT)
public abstract class AbstractAufgabeEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<Aufgabe>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "aufgabeEditView";

  public static final String VIEW_ID = "/aufgabe/aufgabe-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/aufgabe/aufgabe-search.xhtml";

  @Inject
  protected transient AufgabeExtendedDAO extendedDAO;

  @Inject
  protected transient AufgabeEdit edit;

  @Inject
  @ConversationGroup(AufgabeConversationStore.class)
  protected transient AufgabeConversationStore conversationStore;

  @Inject
  protected transient AufgabeMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient AufgabeEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public Aufgabe getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(Aufgabe entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.AUFGABE_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(Aufgabe entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.AUFGABE_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.AUFGABE_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.AUFGABE_EDIT)
  @Override
  public String save() {
    Aufgabe entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Aufgabe entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    Aufgabe entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(Aufgabe entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.AUFGABE_EDIT);
  }
  
  @Redirect
  public String edit(Aufgabe entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class AufgabeEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<Aufgabe,   de.ivu.elect.business.aufgabe.entity.AufgabePK  > {

    private static final long serialVersionUID = 1L;
  }
}
